#ifndef ARFF_H
#define ARFF_H

using namespace std;
#include <vector>
#include <string>
#include <map>
#include <stdio.h>

class arff  {
    bool attributeAlwaysNumeric(const string &s) const;
    bool attributeAlwaysDate(const string &s) const;
public:
    enum type {
	NUMERIC=1,
	NOMINAL=2,
	STRING=3,
	DATE=4
    };
    typedef std::map<string,int> attributeMapT;
    vector<string> attributeNames;
    vector<int>    attributeTypes;
    attributeMapT  attributeCodes;
	
    typedef std::map<int,string> valueMapT; // attribute number -> value

    vector<string>comments;
    string relation;
    vector<valueMapT *>values;

    arff(string relation_name){
	relation = relation_name;
    };
    void output(FILE *out);
    void add_comment(string comment);	
    void add_attribute(string name,int type);
    void add_value(string name,int number);
    void add_value(string name,const string &value);
    void add_valuet(string name,time_t t);
    void new_row();				// go to the next row
    int  attributeCol(const string &attributeName) const; // returns attribute row
};

#endif
